Exception.HResult Eigenschaft

Definition

Ruft HRESULT ab oder legt HRESULT fest. Dies ist ein codierter Wert, der einer bestimmten Ausnahme zugeordnet ist.Gets or sets HRESULT, a coded numerical value that is assigned to a specific exception.

protected:
 property int HResult { int get(); void set(int value); };
protected int HResult { get; set; }
member this.HResult : int with get, set
Protected Property HResult As Integer

Eigenschaftswert

Der HRESULT-Wert.The HRESULT value.

Beispiele

Im folgenden Codebeispiel wird eine abgeleitete Exception Klasse definiert, die die HResult -Eigenschaft auf einen benutzerdefinierten Wert in Ihrem Konstruktor festlegt.The following code example defines a derived Exception class that sets the HResult property to a custom value in its constructor.

// Example for the Exception::HResult property.
using namespace System;

namespace NDP_UE_CPP
{

   // Create the derived exception class.
   ref class SecondLevelException: public Exception
   {
   private:
      static int SecondLevelHResult = (int)0x81234567;

   public:

      // Set HResult for this exception, and include it in 
      // the exception message.
      SecondLevelException( String^ message, Exception^ inner )
         : Exception( String::Format( "(HRESULT:0x{1:X8}) {0}", message, SecondLevelHResult ), inner )
      {
         HResult = SecondLevelHResult;
      }

   };


   // This function forces a division by 0 and throws 
   // a second exception.
   void DivideBy0()
   {
      try
      {
         try
         {
            int zero = 0;
            int ecks = 1 / zero;
         }
         catch ( Exception^ ex ) 
         {
            throw gcnew SecondLevelException( "Forced a division by 0 and threw "
            "a second exception.",ex );
         }

      }
      catch ( Exception^ ex ) 
      {
         Console::WriteLine( ex->ToString() );
      }

   }

}

int main()
{
   Console::WriteLine( "This example of Exception::HResult "
   "generates the following output.\n" );
   NDP_UE_CPP::DivideBy0();
}

/*
This example of Exception::HResult generates the following output.

NDP_UE_CPP.SecondLevelException: (HRESULT:0x81234567) Forced a division by 0 an
d threw a second exception. ---> System.DivideByZeroException: Attempted to div
ide by zero.
   at NDP_UE_CPP.DivideBy0()
   --- End of inner exception stack trace ---
   at NDP_UE_CPP.DivideBy0()
*/
// Example for the Exception.HResult property.
using System;

namespace NDP_UE_CS
{
    // Create the derived exception class.
    class SecondLevelException : Exception
    {
        const int SecondLevelHResult = unchecked( (int)0x81234567 );

        // Set HResult for this exception, and include it in 
        // the exception message.
        public SecondLevelException( string message, Exception inner ) :
            base( string.Format( "(HRESULT:0x{1:X8}) {0}", 
                message, SecondLevelHResult ), inner )
        {
            HResult = SecondLevelHResult;
        }
    }

    class HResultDemo 
    {
        public static void Main() 
        {
            Console.WriteLine( 
                "This example of Exception.HResult " +
                "generates the following output.\n" );

            // This function forces a division by 0 and throws 
            // a second exception.
            try
            {
                try
                {
                    int  zero = 0;
                    int  ecks = 1 / zero;
                }
                catch( Exception ex )
                {
                    throw new SecondLevelException( 
                        "Forced a division by 0 and threw " +
                        "a second exception.", ex );
                }
            }
            catch( Exception ex )
            {
                Console.WriteLine( ex.ToString( ) );
            }
        }
    }
}

/*
This example of Exception.HResult generates the following output.

NDP_UE_CS.SecondLevelException: (HRESULT:0x81234567) Forced a division by 0 and
 threw a second exception. ---> System.DivideByZeroException: Attempted to divi
de by zero.
   at NDP_UE_CS.HResultDemo.Main()
   --- End of inner exception stack trace ---
   at NDP_UE_CS.HResultDemo.Main()
*/
' Example for the Exception.HResult property.
Namespace NDP_UE_VB

    ' Create the derived exception class.
    Class SecondLevelException
        Inherits Exception

        Private Const SecondLevelHResult As Integer = &H81234567
       
        ' Set HResult for this exception, and include it in 
        ' the exception message.
        Public Sub New(message As String, inner As Exception)

            MyBase.New( String.Format( "(HRESULT:0x{1:X8}) {0}", _
                message, SecondLevelHResult ), inner )
            HResult = SecondLevelHResult
        End Sub
    End Class

    Module HResultDemo
       
        Sub Main()
            Console.WriteLine( _
                "This example of Exception.HResult " & _
                "generates the following output." & vbCrLf )
              
            ' This function forces a division by 0 and throws 
            ' a second exception.
            Try
                Try
                    Dim zero As Integer = 0
                    Dim ecks As Integer = 1 \ zero

                Catch ex As Exception
                    Throw New SecondLevelException( _
                        "Forced a division by 0 and threw " & _
                        "a second exception.", ex )
                End Try
              
            Catch ex As Exception
                Console.WriteLine( ex.ToString( ) )
            End Try
        End Sub

    End Module ' HResultDemo
End Namespace ' NDP_UE_VB

' This example of Exception.HResult generates the following output.
' 
' NDP_UE_VB.SecondLevelException: (HRESULT:0x81234567) Forced a division by 0 a
' nd threw a second exception. ---> System.DivideByZeroException: Attempted to
' divide by zero.
'    at NDP_UE_VB.HResultDemo.Main()
'    --- End of inner exception stack trace ---
'    at NDP_UE_VB.HResultDemo.Main()

Hinweise

HRESULT ist ein 32-Bit-Wert, der in drei verschiedene Felder unterteilt ist: einen Schweregrad Code, einen Einrichtungs Code und einen Fehlercode.HRESULT is a 32-bit value, divided into three different fields: a severity code, a facility code, and an error code. Der Schweregrad Code gibt an, ob der Rückgabewert Informationen, eine Warnung oder einen Fehler darstellt.The severity code indicates whether the return value represents information, warning, or error. Der Einrichtungs Code identifiziert den Bereich des Systems, der für den Fehler verantwortlich ist.The facility code identifies the area of the system responsible for the error. Der Fehlercode ist eine eindeutige Zahl, die zur Darstellung der Ausnahme zugewiesen wird.The error code is a unique number that is assigned to represent the exception. Jede Ausnahme ist einem eindeutigen HRESULT zugeordnet.Each exception is mapped to a distinct HRESULT. Wenn verwalteter Code eine Ausnahme auslöst, übergibt die Laufzeit das HRESULT an den com-Client.When managed code throws an exception, the runtime passes the HRESULT to the COM client. Wenn nicht verwalteter Code einen Fehler zurückgibt, wird das HRESULT in eine Ausnahme konvertiert, die dann von der Laufzeit ausgelöst wird.When unmanaged code returns an error, the HRESULT is converted to an exception, which is then thrown by the runtime. Informationen zu HRESULT-Werten und den zugehörigen .NET Framework Ausnahmen finden Sie unter Gewusst wie: Zuordnen von HRESULTs undAusnahmen.For information about HRESULT values and their corresponding .NET Framework exceptions, see How to: Map HRESULTs and Exceptions. Eine Liste der Werte, auf die Sie am wahrscheinlichsten stoßen, finden Sie unter Allgemeine HRESULT-Werte in der Windows-Dokumentation.See Common HRESULT Values in the Windows documentation for a list of the values you are most likely to encounter.

Beginnend mit .NET Framework 4.5.NET Framework 4.5wird der Setter HResult der Eigenschaft geschützt, während der zugehörige Getter öffentlich ist.Starting with the .NET Framework 4.5.NET Framework 4.5, the HResult property's setter is protected, whereas its getter is public. In früheren Versionen der .NET Framework sind Getter und Setter geschützt.In previous versions of the .NET Framework, both getter and setter are protected.

Gilt für:

Siehe auch